var influx = require('influx');
var flatten = require('flat');
var unflatten = flatten.unflatten;
var _ = require('lodash');


var Firewatch = function(url){
  if(url) {
    this.db = influx(url)
  }
  return this;
}



var createClient = function (url) {
  var Client = function () { return Firewatch.apply(this, url) }
  Client.prototype = Firewatch.prototype
  return new Firewatch(url)
}



/*************************************************
                   Post data 
**************************************************/
_preparePointForWrite = function(point){

  point.values = point.values || { value : 1 }
  console.log('before prepare', point.values)
  if(point.values.time)
    point.values.time = new Date(point.values.time).getTime();
  else if(point.time) 
    point.values.time = new Date(point.time).getTime();
  
  if(point.values.value===undefined)
    point.values.value = 1
  point.values = flatten(point.values)
  // check null value
  //console.log('after flatten', point.values);
  _.forEach(point.values, function(value, key){
    console.log('key:value ' , key +':'+ value);
    if(value == null){
      point.values[key] = 0;
    } else if(Array.isArray(value) && value.length == 0) {
      delete point.values[key]
    }
  });
  console.log('after prepare null values', point.values);
  point.tags = flatten(point.tags)
  return point;
}

Firewatch.prototype.post = function(measurement, points, callback) {
  if(Array.isArray(points)) {
    var formatedPoints = [];
    points.forEach(function(point, index){
      point = _preparePointForWrite(point);
      formatedPoints.push([ point.values, point.tags ]);
    });
    this.db.writePoints(measurement, formatedPoints, function(err , response) {
      console.log( err, response )
      callback(err, response )
    });  
  } else {
    var point = _preparePointForWrite(points);
    this.db.writePoint(measurement, point.values, point.tags, function(err , response) {
      console.log( err, response )
      callback(err, response );
    });  
  }
}


/*************************************************
                   Post event data 
**************************************************/
//
//
// Firewatch.prototype.postEvent = function(measurement, points, callback) {
//   if(Array.isArray(points)) {
//     var formatedPoints = [];
//     points.forEach(function(point, index){
//       point = _preparePointForWrite(point);
//       formatedPoints.push([ point.values, point.tags ]);
//     });
//     this.db.writePoints(measurement, formatedPoints, function(err , response) {
//       console.log( err, response )
//       callback(err, response )
//     });
//   } else {
//     var point = _preparePointForWrite(points);
//     this.db.writePoint(measurement, point.values, point.tags, function(err , response) {
//       console.log( err, response )
//       callback(err, response );
//     });
//   }
// }


/*************************************************
                   Aggregate data 
**************************************************/
Firewatch.prototype.aggregate = function(measurement, opts , callback ){
  var self = this;
  var query = opts.query;
  var operator = opts.operator || 'SUM';
  // generate condition from object to text
  var groupByText = ' GROUP BY ' + opts.groupBy;
  
  var queryText = "",queryTexts = [];
  console.log('before transform query ' + opts.query);
  _.forEach( query , function(value, field){
    if(typeof value == "object") {
      console.log(value);
      value = _operatorToText(value);
      console.log('transform to ' + value );
      queryTexts.push(field+value);
    } else
      queryTexts.push(field+'=\''+value+'\'');
   
  });
  if(queryTexts.length > 0)
    queryText = " WHERE " + queryTexts.join(' and ');
  
  
  // get field list from measurement
  var fieldQuery = 'SHOW FIELD KEYS FROM "' + measurement + '"'
  self.db.query( fieldQuery, function(err, fields){

    if(fields == undefined || fields[0].length==0) return callback({error : 'no values in table'});
    console.log(fields[0]);
    // generate aggregate field from  field value after  request it from influx db
    aggFields = [];
    aggFieldText = '';
    _.forEach( fields[0] , function(field){
      aggFields.push('SUM("' + field['fieldKey'] + '") as "' + field['fieldKey'] + '"');
      aggFieldText = aggFields.join(',');
    });
    
    // get field list from measurement
    // var tagQuery = 'SHOW TAG KEYS FROM "' + measurement + '"'
    // self.db.query( tagQuery, function(err, fields){
    //   console.log(fields[0]);
    //   if(fields[0].length==0) return callback({error : 'no values in table'});
    //   // generate aggregate field from  field value after  request it from influx db
    //   _.forEach( fields[0] , function(field){
    //     aggFields.push(field['tagKey'])
    //
    //   });
    //   aggFieldText = aggFields.join(',');
      //select sum(total) as total from "brickman-dev.revenue_stat_test" where time= '2016-07-27T17:00:00Z'   group by channel, time(1d)
    var query = 'SELECT ' + aggFieldText + ' FROM "' + measurement + '"' +  queryText + groupByText;
    console.log(query);
    self.db.query( query, function(err, results) { 
      if(err)
        console.log(err, results)
      //TODO: reformat series to easiest json way
      json = []
      _.forEach( results[0] , function(row){ 
        json.push(unflatten(row));
      });
      callback(err , json)
    });
      //});
  });
}
/*************************************************
                   Get data 
**************************************************/
/*
  conditions = {
    time : 
    groupBy
  }

*/
Firewatch.prototype.get = function(measurement, conditions , callback ){
  var time = date.getTime() * 1000000;
  // var textConditions = conditions.join
  
  var query = 'SELECT ' + fields + ' FROM "' + measurement + '" WHERE ' + conditions ;
  console.log(query);
  this.db.query( query, function(err, results) { 
    /* result format
      array of series
        -array of record
          -tag,value
    
    */
    result = results[0]
    if(err) console.log( err, results);
    groups = {}
    overall = {}
    callback(err, result);
    // for series in results[0]
    //   group = series#[0]
  });
}

/*
  recieve js date
*/
Firewatch.prototype.getByDate = function(measurement, date, callback ){
  var time = date.getTime() * 1000000;
  query = 'SELECT * FROM "' + measurement + '" WHERE time = ' + time;
  //select sum(total) from "brickman-dev.revenue_stat_test" where time= '2016-07-27T17:00:00Z'  group by channel
  console.log(query);
  this.db.query( query, function(err, results) { 
    /* result format
      array of series
        -array of record
          -tag,value
    
    */
    result = results[0]
    if(err) console.log( err, results);
    groups = {}
    overall = {}
    callback(err, result);
    // for series in results[0]
    //   group = series#[0]
  });
}


var _operatorToText = function(condition) {
  var text = "";
  _.forEach(condition, function(value, op){
    text = OPS[op] + "'" + value + "'";
  });
  return text;


}

var OPS = {
  "$gte" : ">=",
  "$lte" : "<=",
  "$gt" : ">",
  "$lt" : "<",
  "$ne" : "!=",
}

module.exports = exports = createClient;