var Firewatch = require('../index.js')
var influx = require('influx')
var assert = require('assert')


describe('Firewatch', function () {
  
  var dburi = 'http://influxdb:staging@104.199.163.71:8086/firewatch';
  var firewatch = Firewatch(dburi);
  var table = "response_time";
  // describe('connect', function(){
  //   var firewatch = Firewatch(dburi);
  //   it('success', function(){
  //     assert(firewatch.db instanceof influx.InfluxDB)
  //   });
  // });
  //
  describe('#Post - single', function () {
    var params = {
      values : { value1 : 1 , value2 : 2 },
      tags : {type : 'single' , tag2 : 't0' }
    };
    it('save complete', function (done) {
      firewatch.post(table, params , function(err, response){
        console.log(err, response);
        assert(err == null);
        done()
      });
    });
  });
  
  describe('#Post - multiple', function () {

    var params = [];
    var currentDate = new Date();
    for(var i= 0; i<3; i++) {
      var param = {
        values : { value1 : i , value2 : i , time :  currentDate},
        tags : {type : 'multiple' , rev : 't'+i }
      };
      params.push(param);
    }
    console.log(params);
    it('save complete', function (done) {
      firewatch.post(table, params , function(err, response){
        console.log(err, response);
        assert(err == null);
        done();
      });
    });
    
    it('got corrected data', function (done) {
      firewatch.getByDate(table, currentDate , function(err, response){
        console.log(err, response);
        assert(err == null);
        done();
      });
    });
    
    
  });
  
  describe('#GET - aggregate by date', function(){
    Firewatch.get(table)
    
  });
});